# Copyright (c) 2003 LOGILAB S.A. (Paris, FRANCE).
# http://www.logilab.fr/ -- mailto:contact@logilab.fr
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

"""
A very simple confirmation aspect
"""

__revision__ = '$Id: confirmation.py,v 1.3 2003/06/16 15:23:39 adim Exp $'

from logilab.aspects.core import AbstractAspect


class ConfirmationAbstractAspect(AbstractAspect):
    """Confirmation abstract aspect
    """
    def __init__(self, cls, met_name):
        AbstractAspect.__init__(self, cls, met_name)
        

    def _do_confirm(self):
        """This defines how to ask confirmation. It should return
        True if user confirms, else False.
        Abstract method : must be  implemented in subclasses.
        """
        raise NotImplementedError
    
        
    def around(self, wobj, *args, **kwargs):
        """Around implementation of aspect interface
        """
        if self._do_confirm():
            self._proceed(wobj, *args, **kwargs)


