#!/usr/bin/env python
#
# Copyright (c) 2003 LOGILAB S.A. (Paris, FRANCE).
# http://www.logilab.fr/ -- mailto:contact@logilab.fr
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

"""
Allow to launch all tests
"""

__revision__ = '$Id: run_tests.py,v 1.1 2003/06/17 07:33:24 adim Exp $'

import unittest

import imp
import os

def get_suite_list():
    """Retrieves all testsuites of this directory.
    All files whose name looks like 'unittest_XXX.py' is considered
    as a module
    """

    suite_list = []

    for filename in os.listdir('.'):
        if filename.startswith('unittest_') and \
           filename.endswith('.py'):
            module_name = filename[:-3]
            try:
                file_obj, path, desc = imp.find_module(module_name, ['.'])
                mod = imp.load_module('aspects.tests.'+module_name, file_obj,
                                      path, desc)
            
                suite_func = getattr(mod, 'suite')
                suite_list.append(suite_func())
            except ImportError:
                print "unable to load %s"%module_name
                
    return suite_list


def suite():
    """All tests
    """

    suite_list = get_suite_list()
    return unittest.TestSuite(suite_list)


if __name__ == '__main__':
    unittest.main(defaultTest = 'suite')
    
